/*
 * Copyright ©Rastislav Mirek. All rights reserved.
 * No waranty for this software or derived works.
 */

package cz.muni.fi.pb162.contactsexample.catalog;

/**
 * This class represents Person.
 *
 * Created 10.12.2009 at 5:04:51.
 *
 * @author Rastislav Mirek <rmirek at mail.muni.cz>
 * @version %I%, %G%
 * @since 1.0
 */
public class Person implements Comparable<Person>{

    private String firstName;
    private String surname;
    private String note;

    public Person(String firstName, String surname, String note) {
        if(firstName == null){
            throw new NullPointerException("firstName");
        }
        if(firstName.isEmpty()){
            throw  new IllegalArgumentException("firstName is empty");
        }
        this.firstName = firstName;
        this.surname = surname;
        this.note = note;
    }

    public String getFirstName() {
        return firstName;
    }

    public String getSurname() {
        return surname;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (!(obj instanceof Person)) {
            return false;
        }

        Person other = (Person) obj;
        return firstName.equals(other.firstName)
                && surname == null? other.surname == null: surname.equals(other.surname);
    }

    @Override
    public int hashCode() {
        return 7 * firstName.hashCode() + 13 * (surname == null? 0 : surname.hashCode());
    }

    public int compareTo(Person o) {
        return this.firstName.compareTo(o.firstName);
    }



}
